<?php

/**
 * @file
 * Contains \Drupal\miniorange_saml\Form\MiniorangeSPInformation.
 */

namespace Drupal\miniorange_saml\Form;

use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml\Utilities;
use Drupal\miniorange_saml\MetadataReader;

class MiniorangeSPInformation extends FormBase {
    /**
    * {@inheritdoc}
    */
    public function getFormId() {
        return 'miniorange_sp_setup';
    }

    public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state) {
        global $base_url;

        $form['markup_library'] = array(
            '#attached' => array(
                'library' => array(
                    "miniorange_saml/miniorange_saml.test",
                    "miniorange_saml/miniorange_saml.admin",
                )
            )
        );

        $form['markup_top'] = array(
            '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container">'
        );

        Utilities::visual_tour_start($form, $form_state);

        $form['miniorange_saml_IDP_tab'] = array(
            '#attached' => array(
	            'library' => array(
	                'miniorange_saml/miniorange_saml.test',
                    'miniorange_saml/miniorange_saml.Vtour'
                )
            ),
            '#markup' => '<div id="tabhead"><h5> Enter the information gathered from your Identity Provider &nbsp; OR &nbsp;&nbsp;
                            <a id="showMetaButton" class="btn btn-primary btn-sm" onclick="testConfig()">Upload IDP Metadata</a>&nbsp;&nbsp;&nbsp;&nbsp;
                                <a id="Restart_moTour" class="btn btn-danger btn-sm" onclick="Restart_moTour()">Take a Tour</a><br><br><hr></h5></div>',
        );

        $form['metadata_1'] = array(
            '#markup' =>'<div border="1" id="upload_metadata_form" class="mo_saml_meta_upload">
				<h3>UPLOAD IDP METADATA</h3><hr><br><span class="mo_saml_cancel_upload">
				<a id="hideMetaButton" class="btn btn-sm btn-danger" onclick = "testConfig()">Cancel</a></span>',
        );

        $form['miniorange_saml_idp_name_3'] = array(
            '#type' => 'textfield',
            '#title' => t('Identity Provider Name<span style="color: #FF0000">*</span>'),
            '#attributes' => array('placeholder' => 'Enter Identity Provider name.','style' => 'width:73%'),
        );

        $form['metadata_2'] = array(
            '#markup' =>' <br></h1><h4>Upload Metadata  :</h4>',
        );
  
        $form['metadata_file'] = array(
            '#type' => 'file',
        );
  
        $form['metadata_upload'] = array(
            '#type' => 'submit',
            '#value' => t('Upload File'),
            '#submit' => array('::miniorange_saml_upload_file'),
            '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
        );
  
        $form['metadata_3'] = array(
            '#markup' =>'<p>&emsp;&emsp;&emsp;&emsp;<b>OR</b></p>'
	        .'			<h4>Enter metadata URL:</h4>',
        );
  
        $form['metadata_URL'] = array(
            '#type' => 'textfield',
	        '#attributes' => array('style' => 'width:73%','placeholder' => 'Enter metadata URL of your IdP.'),
        );

        $form['metadata_fetch'] = array(
            '#type' => 'submit',
            '#value' => t('Fetch Metadata'),
            '#submit' => array('::miniorange_saml_fetch_metadata'),
            '#attributes' => array('style' => 'background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
            '#suffix' => '<br><br>',
        );

        $form['miniorange_saml_fetch_metadata_1'] = array(
            '#type' => 'checkbox',
            '#title' => t('Update IdP settings by pinging metadata URL (We will store the metadata URL). <b><a href="' . $base_url . '/admin/config/people/miniorange_saml/Licensing">[Premium, Enterprise]</a></b>'),
            '#disabled' => TRUE,
        );

        $form['metadata_fetch_1'] = array(
            '#markup' => '<div class="mo_saml_highlight_background_note_1"><b>Note: </b>You can set how often you want to ping the IdP from <b><a target="_blank" href="' . $base_url . '/admin/config/system/cron "> Here</a> OR </b> you can goto <b>Configuration=>Cron=>Run Cron Every</b> section of your drupal site.</div><br>',
        );
   
        $form['metadata_5'] = array(
            '#markup' =>'<hr></div>'
	            .'<div id="idpdata">',
        );

        $form['miniorange_saml_idp_name'] = array(
            '#type' => 'textfield',
            '#title' => t('Identity Provider Name<span style="color: #FF0000">*</span>'),
            '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_name'),
            '#attributes' => array('style' => 'width:73%', 'placeholder' => 'Identity Provider Name'),
            '#prefix' =>'<div id = "miniorange_saml_idp_name_div">',
            '#suffix' =>'</div>',
        );

        $form['miniorange_saml_idp_issuer'] = array(
            '#type' => 'textfield',
            '#title' => t('IdP Entity ID or Issuer<span style="color: #FF0000">*</span>'),
            '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_issuer'),
            '#attributes' => array('style' => 'width:73%','placeholder' => 'IdP Entity ID or Issuer'),
	        '#description' => t('<b>Note :</b> You can find the EntityID in Your IdP-Metadata XML file enclosed in <code>EntityDescriptor</code> tag having<br> attribute as <code>entityID</code>'),
            '#prefix' =>'<div id = "miniorange_saml_idp_issuer_div">',
            '#suffix' =>'</div>',
        );

        $form['miniorange_saml_idp_login_url'] = array(
            '#type' => 'textfield',
            '#title' => t('SAML Login URL<span style="color: #FF0000">*</span>'),
            '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_login_url'),
            '#description' => t('<b>Note :</b> You can find the SAML Login URL in Your IdP-Metadata XML file enclosed in <code>SingleSignOnService</code><br> tag'),
            '#attributes' => array('style' => 'width:73%', 'placeholder' => 'SAML Login URL'),
            '#prefix' =>'<div id="miniorange_saml_idp_login_url_start">',
            '#suffix' =>'</div>',
        );

        $form['miniorange_saml_nameid_format'] = array(
            '#type' => 'select',
            '#title' => t('NameID Format <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[Premium]</b></a>'),
            '#options' => array('urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress' => t('urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress'),),
            '#attributes' => array('style' => 'width:73%'),
            '#description' => t('<b>Note :</b> This feature is available in the premium version of the module.'),
            '#disabled' => TRUE,
        );

        $form['myradios'] = array(
            '#title' => t('x.509 Certificate Value'),
            '#type' => 'radios',
            '#options' => array(
                'text' => 'Enter as Text',
                'upload' => 'Upload Certificate',
            ),
            '#default_value' => 'text',
            '#suffix' => '<br><div id="miniorange_saml_idp_x509_certificate_start">',
            '#prefix' => '<br>',
        );

        $form['miniorange_saml_idp_x509_certificate'] = array(
            '#type' => 'textarea',
            '#cols' => '10',
            '#rows' => '5',
            '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_x509_certificate'),
            '#attributes' => array('style' => 'width:73%','placeholder' => 'Enter x509 Certificate Value'),
            '#description'=>t('<b>NOTE:</b> Format of the certificate:<br><b>-----BEGIN CERTIFICATE-----<br>XXXXXXXXXXXXXXXXXXXXXXXXXXX<br>-----END CERTIFICATE-----</b><br><br>'),
            '#suffix' => '</div>',
        );

        $form['mo_saml_cert_file'] = array(
            '#type' => 'file',
            '#attributes' => array('style' => 'float: left; margin-top: 14px; margin-right: 10px;'),
            '#prefix' => '<div id="mo_saml_file" class="mo_saml_hidden"> <h5>Upload Certificate</h5>',
        );

        $form['metadata_upload_cert_file'] = array(
            '#type' => 'submit',
            '#value' => t('Upload'),
            '#submit' => array('::mo_saml_upload_certificate'),
            '#attributes' => array('style' => 'margin-top: 13px; border-radius: 4px; background: #337ab7; color: #ffffff; text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
            '#suffix' => '</div><br><br>',
        );

        $form['miniorange_saml_enable_login'] = array(
            '#type' => 'checkbox',
            '#title' => t('Enable login with SAML'),
            '#default_value' => \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_enable_login'),
            '#prefix' => '<div id="enable_login_with_saml">',
            '#suffix' => '</div>'
        );

        $form['security_signature_algorithm'] = array(
            '#type' => 'select',
            '#title' => t('Signature algorithm <a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[Enterprise]</b></a>'),
            '#options' => ['RSA_SHA256' => 'sha256'],
            '#description' => t('Algorithm used in the signing process. (Algorithm eg. sha256, sha384, sha512, sha1 etc)'),
            '#attributes' => array('style' => 'width: 50%'),
            '#disabled' => TRUE,
        );

        $form['miniorange_saml_sign_request'] = array(
            '#type' => 'checkbox',
            '#title' => t('Check this option to send Signed SSO and SLO requests.<a href="' . $base_url . '/admin/config/people/miniorange_saml/licensing"> <b>[Standard, Premium, Enterprise].</b></a>'),
            '#disabled' => TRUE,
            '#prefix' => '<div class="mo_saml_highlight_background_note">',
            '#suffix' => '</div><br><br>',
        );

        $form['miniorange_saml_idp_config_submit'] = array(
            '#type' => 'submit',
            '#value' => t('Save Configuration'),
        );

        $form['miniorange_saml_test_config_button'] = array(
	        '#attached' => array ('library' => 'miniorange_saml/miniorange_saml.test',),
            '#markup' => '<a id="testConfigButton" class="btn btn-primary btn-sm" onclick="testConfig();">Test Configuration</a>'
        );

        $form['miniorange_saml_test_show_SAML_request_button'] = array(
	        '#attached' => array(
	            'library' => 'miniorange_saml/miniorange_saml.button',
	        ),
            '#markup' => '<br><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a id="showSAMLrequestButton" class="btn btn-primary btn-sm mo_btn_style" onclick="showSAMLRequest();">Show SAML Request</a>&nbsp;&nbsp;&nbsp;'
        );

        $form['miniorange_saml_test_show_SAML_response_button'] = array(
            '#attached' => array(
                'library' => 'miniorange_saml/miniorange_saml.button',
            ),
            '#markup' => '&nbsp;&nbsp;&nbsp;<a id="showSAMLresponseButton" class="btn btn-primary btn-sm" onclick="showSAMLResponse();">Show SAML Response</a>',
            '#suffix' => '</div><br><br></div>',
        );

        Utilities::spConfigGuide($form, $form_state);

        $form['miniorange_sp_guide_link_end'] = array(
            '#markup' => '</div>',
        );

        Utilities::AddSupportButton($form, $form_state);

        return $form;
    }

    public function miniorange_saml_form_alter(array &$form, \Drupal\Core\Form\FormStateInterface $form_state, $form_id){
        $form['actions']['submit']['#submit'][] = 'test';
	    return $form;
	}

    function mo_saml_upload_certificate(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

        $certificate = $_FILES['files']['tmp_name']['mo_saml_cert_file'];
        if(!empty($certificate)) {
            $file_name = $_FILES['files']['name']['mo_saml_cert_file'];
            list($name_without_extention, $extention) = explode('.', $file_name);
            if($extention == 'crt' || $extention == 'cer')
            {
                $cert_content = file_get_contents($certificate);
                $idp_name = $form['miniorange_saml_idp_name']['#value'];
                $issuer = $form['miniorange_saml_idp_issuer']['#value'];
                $login_url = $form['miniorange_saml_idp_login_url']['#value'];

                \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_name', $idp_name)->save();
                \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_issuer', $issuer)->save();
                \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_login_url', $login_url)->save();
                \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_x509_certificate', $cert_content)->save();
                drupal_set_message(t('x.509 Certificate Value successfully updated.'));
            }else {
                drupal_set_message(t('<b style="color: red">File type is not compatible</b> <br> Please Select <b style="color: red">".crt"</b> or <b style="color: red">".cer"</b> extended file to upload Configuration!'),'error');
            }
        }else {
            drupal_set_message(t('<b style="color: red">Please select file first to upload Configuration!</b>'),'error');
        }
    }

    /**
    * Configure IdP.
    */
    public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
        global $base_url;
        $issuer = $form['miniorange_saml_idp_issuer']['#value'];
        $idp_name = $form['miniorange_saml_idp_name']['#value'];
        $nameid_format = 'urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified';
        $login_url = $form['miniorange_saml_idp_login_url']['#value'];
        $x509_cert_value = Utilities::sanitize_certificate($form['miniorange_saml_idp_x509_certificate']['#value']);
        $enable_login_value = $form['miniorange_saml_enable_login']['#value'];

        if(empty($idp_name)||empty($issuer) || empty($login_url)){
            drupal_set_message(t('The <b><u>Identity Provider Name, IdP Entity ID or Issuer</u></b> and <b><u>SAML Login URL</u></b> fields are mandatory.'), 'error');
            return;
        }

        $enable_login = FALSE;
        if ($enable_login_value == 1) {
            $enable_login = TRUE;
        }

        $sp_issuer = $base_url . '/samlassertion';

        \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_base', $base_url)->save();
        \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_name', $idp_name)->save();
        \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_sp_issuer', $sp_issuer)->save();
        \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_issuer', $issuer)->save();
        \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_nameid_format', $nameid_format)->save();
        \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_login_url', $login_url)->save();
        \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_x509_certificate', $x509_cert_value)->save();
        \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_enable_login', $enable_login)->save();

        drupal_set_message(t('Identity Provider Configuration successfully saved'));
    }

    function saved_support(array &$form, \Drupal\Core\Form\FormStateInterface $form_state)
    {
        $email = $form['miniorange_saml_email_address_support']['#value'];
        $phone = $form['miniorange_saml_phone_number_support']['#value'];
        $query = $form['miniorange_saml_support_query_support']['#value'];
        Utilities::send_support_query($email, $phone, $query);
    }
 
    function miniorange_saml_upload_file(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
        $idp_name = $form['miniorange_saml_idp_name_3']['#value'];
    	$file_name = $_FILES['files']['tmp_name']['metadata_file'];
    	$file = file_get_contents($file_name);
    	$this->upload_metadata($file, $idp_name);
    }

    function miniorange_saml_fetch_metadata(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
        $idp_name = $form['miniorange_saml_idp_name_3']['#value'];
    	$url=filter_var($form['metadata_URL']['#value'],FILTER_SANITIZE_URL);
    	$arrContextOptions=array(
    	    "ssl"=>array(
				"verify_peer"=>false,
				"verify_peer_name"=>false,
            ),
        );
	    $file = file_get_contents($url, false, stream_context_create($arrContextOptions));
	    $this->upload_metadata($file, $idp_name);
    }

    public function upload_metadata($file, $idp_name){

        global $base_url;

        $idp_name_stored = \Drupal::config('miniorange_saml.settings')->get('miniorange_saml_idp_name');
        if(empty($idp_name) && empty($idp_name_stored)){
            drupal_set_message(t('<b><i>Identity Provider Name</i></b> is required.'),error);
            return;
        } elseif(empty($idp_name)){
            $idp_name_value = $idp_name_stored;
        } else {
            $idp_name_value = $idp_name;
        }

    	$document = new \DOMDocument();
		$document->loadXML($file);
		restore_error_handler();
		$first_child = $document->firstChild;

		if(!empty($first_child)) {
			$metadata = new MetadataReader($document);
			$identity_providers = $metadata->getIdentityProviders();
			if(empty($identity_providers)) {
				drupal_set_message(t('Please provide a valid metadata file.'),error);
		    	return;
			}
			
			foreach($identity_providers as $key => $idp) {
				$saml_login_url = $idp->getLoginURL('HTTP-Redirect');
				if(empty($saml_login_url)) {
					$saml_login_url = $idp->getLoginURL('HTTP-POST');
				}
				$saml_issuer = $idp->getEntityID();
				$saml_x509_certificate = $idp->getSigningCertificate();
				$sp_issuer = $base_url;


				\Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_name', $idp_name_value)->save();
                \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_sp_issuer', $sp_issuer)->save();
                \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_issuer', $saml_issuer)->save();
                \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_login_url', $saml_login_url)->save();
                \Drupal::configFactory()->getEditable('miniorange_saml.settings')->set('miniorange_saml_idp_x509_certificate', $saml_x509_certificate[0])->save();
			}
			drupal_set_message(t('Identity Provider Configuration successfully saved.'));
			return;
		}else {
		    drupal_set_message(t('Please provide a valid metadata file.'),error);
		    return;
		}
    }
}